#include<iostream>
using namespace std;
int main()
{
    int a, b, c,d, x;
    cin>>a>>b>>c>>d>>x;
    a=a*a*a;
    b=b*b*b;
    c=c*c*c;
    d=d*d*d;
    x=x*x*x;
    if (a+b+c+d<=x)
    {
        cout<<1<<endl;
    }
    if ((a+b+c+d>x) && (a+b+c+d-x<=x))
    {
        cout<<2<<endl;
    }
    if ((a+b+c+d-x<=x*2) && (a+b+c+d>x))
    {
        cout<<3<<endl;
    }
    if ((a+b+c+d-x<=x*3) && (a+b+c+d>x*2))
    {
        cout<<4<<endl;
    }
    if (a+b+c+d>x*4)
    {
        if ((a+b+c+d)%x==0)
        {
            cout<<(a+b+c+d)/x<<endl;
        }
        else
        {
            cout<<(a+b+c+d)/x+1<<endl;
        }
    }
}